<?php
/**
 * @package   Switips
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

//jbdump($params);

class SwitipsControllerCategories extends JControllerLegacy
{
  
  public $redirect_categories = 'index.php?option=com_switips&controller=categories';

  function __construct($config = array()){
    parent::__construct( $config );
    $this->registerTask('apply', 'save');
  }
  
  function display($cachable = false, $urlparams = false){

    JModelLegacy::addIncludePath(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_virtuemart' . DIRECTORY_SEPARATOR . 'models');

    $_categories = JModelLegacy::getInstance('category', 'VirtueMartModel');
    $categories = $_categories->getCategoryTree();
    $commission = $this->getCommission();
    
    foreach($categories as $key=>$cat){
      if(isset($commission[$cat->virtuemart_category_id ])){
        $categories[$key]->commission = $commission[$cat->virtuemart_category_id ];
      }
    }
    $view = $this->getView('switips', 'html');
    $view->setLayout('categories');
    $view->assign('categories', $categories);
    $view->displayCategories();
    
  }
  
  public function save(){
    if ($this->checkToken['save']){
      JSession::checkToken() or die('Invalid Token');
    }

    $data = $this->input->post->getArray();

    if(isset($data['category']) && is_array($data['category'])){
      $this->saveCommission($data['category']); 
    }
    
   $this->setRedirect($this->redirect_categories); 
  }
  
  function getCommission(){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{
      $query = 'SELECT `virtuemart_category_id`, `commission` FROM  #__virtuemart_categories';
      $db->setQuery($query);
      $list = $db->loadAssocList();
      
      $return = [];
      foreach($list as $l){
        $return[$l['virtuemart_category_id']] = !empty($l['commission']) ? $l['commission'] : 0;
      }

      return $return;
    } 
  }
  
  function saveCommission($categories = []){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{      
      
      foreach($categories as $category_id=>$commission){
        $query = $db->getQuery(true);
        $fields = [
          $db->quoteName('commission').'="'.$commission.'"',
        ];
        
        $conditions = [
          $db->quoteName('virtuemart_category_id').'='.$category_id, 
        ];
        
        $query->update($db->quoteName('#__virtuemart_categories'))->set($fields)->where($conditions);
        $db->setQuery($query);
        $db->execute();           
      }
      
      return true;
    } 
  }

}    