<?php
/**
 * @package   Switips
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

//jbdump($params);

class SwitipsControllerProducts extends JControllerLegacy
{
  
  public $redirect_categories = 'index.php?option=com_switips&controller=products';

  function __construct($config = array()){
    parent::__construct( $config );
    $this->registerTask('apply', 'save');
  }
  
  function display($cachable = false, $urlparams = false){
    $check_cat = 0;
    $products = [];
    
    JModelLegacy::addIncludePath(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR . 'com_virtuemart' . DIRECTORY_SEPARATOR . 'models');
    $_categories = JModelLegacy::getInstance('category', 'VirtueMartModel');
    $_products = JModelLegacy::getInstance('product', 'VirtueMartModel');

    $category = $this->input->get('category', 'no');

    if(is_numeric($category)){
      $check_cat = $category;
      $products = $_products->getProductsInCategory((int)$category); 

      $commission = $this->getCommission();

      foreach($products as $key=>$prod){
        if(isset($commission[$prod->virtuemart_product_id])){
          $products[$key]->commission = $commission[$prod->virtuemart_product_id];
        }
      }
      
    }

    $categories = $_categories->getCategoryTree();

    $view = $this->getView('switips', 'html');
    $view->setLayout('products');
    $view->assign('check_cat', $check_cat);
    $view->assign('categories', $categories);
    $view->assign('products', $products);
    $view->displayProducts();
  }
  
  public function save(){
    if ($this->checkToken['save']){
      JSession::checkToken() or die('Invalid Token');
    }

    $data = $this->input->post->getArray();

    if(isset($data['product']) && is_array($data['product'])){
      $this->saveCommission($data['product']); 
    }

    $category = $this->input->get('category', '');
    
    if(is_numeric($category)){
      $this->setRedirect($this->redirect_categories.'&category='.$category);
    }else{
      $this->setRedirect($this->redirect_categories); 
    }   
    
  }
  
  function getCommission(){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{
      $query = 'SELECT `virtuemart_product_id`, `commission` FROM  #__virtuemart_products';
      $db->setQuery($query);
      $list = $db->loadAssocList();
      
      $return = [];
      foreach($list as $l){
        $return[$l['virtuemart_product_id']] = !empty($l['commission']) ? $l['commission'] : 0;
      }

      return $return;
    } 
  }

  function saveCommission($products = []){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{      
      
      foreach($products as $product_id=>$commission){
        $query = $db->getQuery(true);
        $fields = [
          $db->quoteName('commission').'="'.$commission.'"',
        ];
        
        $conditions = [
          $db->quoteName('virtuemart_product_id').'="'.$product_id.'"', 
        ];
        
        $query->update($db->quoteName('#__virtuemart_products'))->set($fields)->where($conditions);
        $db->setQuery($query);
        $db->execute();           
      }
      
      return true;
    } 
  } 
}    